# $Id: multileveldrilldown.py 2969 2010-01-25 14:31:42Z anton $
# $URL: https://svn.non-gnu.uvt.nl/uvt-dev/tags/sources/meresco/bzv-8.4.0/src/delfttilburg/multileveldrilldown.py $
## begin license ##
#
#    "Delft-Tilburg" (delfttilburg) is a package containing shared code
#    between the Delft "Discover" and Tilburg "Beter Zoeken & Vinden" projects.
#    Both projects are based on Meresco Software (http://meresco.com)
#    Copyright (C) 2008-2009 Technische Universiteit Delft http://www.tudelft.nl
#    Copyright (C) 2008-2009 Universiteit van Tilburg http://www.uvt.nl
#    Copyright (C) 2008-2009 Seek You Too (CQ2) http://www.cq2.nl
#
#    This file is part of "Delft-Tilburg".
#
#    "Delft-Tilburg" is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    "Delft-Tilburg" is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with "Delft-Tilburg"; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#
## end license ##
import pprint
import traceback

from merescocore.framework import Observable

class MultiLevelDrilldownException(Exception):
    pass

class MultiLevelDrilldown(Observable):
    def __init__(self):
        self.pp = pprint.PrettyPrinter(indent=2)
        self.fieldFeatures = {}
        Observable.__init__(self)

    def multiLevelDrilldown(self, docset, drilldownFields):
        if self.fieldFeatures == {}:
            self.fieldFeatures = self.any.makeDrilldownDict()

        self.multiLevelDrilldownDict = self.any.getMultiLevelDrilldown()

        for field in drilldownFields:
            if field not in self.multiLevelDrilldownDict:
                raise MultiLevelDrilldownException("Unrecognized drilldownfield: file:section:'%s'" % field)

            resultFieldName, resultTermCounts = None, []
            for levelField  in (self.multiLevelDrilldownDict[field]):
                maximumCount, maxDisplay, sorted = self.fieldFeatures[levelField]
                fieldName, termCounts = self.any.drilldown(docset, [(levelField, maximumCount, sorted)]).next()
                termCounts = list(termCounts)
                if len(termCounts) > 0:
                    resultFieldName, resultTermCounts = fieldName, termCounts
                if len(termCounts) < maximumCount:
                    break

            yield (field, resultFieldName), resultTermCounts

